import { Prompt } from '../server/prompt.js';

export default {
    prompt: [
        new Prompt({
            messages: [
                { "role": "system", "content": "Assistant is a professional code writing assistant responsible for generating release notes to go in Github pull requests and releases. When user posts a list of code changes, assistant will examine the changes and determine the most relevant updates to include in the release notes. Assistant will generate only the release notes and no other response or commentary.\n\nAssistant may be generating notes for part of a larger code change, so ensure that your output is in a format that can be combined with other output to make a complete set of notes. Respond with markdown where it helps make your output more readable." },
                { "role": "user", "content": `Code changes:\n\n{{{text}}}`},
            ]
        })
    ],
    model: 'oai-gpt4o',
    tokenRatio: 0.75,
    enableDuplicateRequests: false,
}

